%global __strip %{mingw32_strip}
%global __objdump %{mingw32_objdump}
%define __debug_install_post %{mingw32_debug_install_post}

# reset patch fuzz, rebasing patches will require delicate surgery -- Rex
%global _default_patch_fuzz 2

Name:    mingw-openjpeg
Version: 1.3
Release: 10%{?dist}
Summary: MinGW Windows openjpeg library

Group:     Development/Libraries
License:   BSD
URL:       http://www.openjpeg.org/
BuildArch:      noarch

BuildRequires: cmake

BuildRequires: mingw32-filesystem
BuildRequires: mingw32-gcc
BuildRequires: mingw32-binutils
BuildRequires: mingw32-libtiff

Source0: http://www.openjpeg.org/openjpeg_v1_3.tar.gz

# Patches from native Fedora package:
Patch1: openjpeg-20070717svn-codec-libtiff.patch
Patch4: openjpeg-svn480-cmake.patch
Patch5: openjpeg-svn480-use-stdbool.patch
Patch6: openjpeg-1.3-tcd_init_encode-alloc-fix.patch
Patch7: openjpeg-1.3-reverse-bogus-aligned-malloc.patch
Patch44: openjpeg-svn468-mj2-noscroll.patch
Patch21: openjpeg-20070717svn-mqc-optimize.patch
Patch22: openjpeg-20070821svn-t1-remove-macro.patch
Patch23: openjpeg-20070719svn-t1-x86_64-flags-branchless.patch
Patch24: openjpeg-20070719svn-t1-t1_dec_sigpass_step-optimize.patch
Patch25: openjpeg-20070821svn-t1-flags-stride.patch
Patch26: openjpeg-20070821svn-t1-updateflags-x86_64.patch
Patch27: openjpeg-svn470-t1-flags-mmx.patch
Patch28: openjpeg-20070719svn-mqc-more-optimize.patch

# libopenjpeg has undefined references, http://bugzilla.redhat.com/467661
Patch50: openjpeg-1.3-libm.patch

# Patches for MinGW:
Patch1000: openjpeg-1.3-mingw32-cmake.patch


%description
%{mingw32_description}


%package -n mingw32-openjpeg
Summary: MinGW Windows openjpeg library

%description -n mingw32-openjpeg
%{mingw32_description}


%{?mingw32_debug_package}


%prep
%setup -q -n OpenJPEG_v1_3
# Make sure we use system libraries
rm -rf libs
%patch1 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch44 -p1
%patch22 -p1
%patch23 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch24 -p1
%patch21 -p1
%patch28 -p1
%patch50 -p1 -b .libm

%patch1000 -p1

# Fix permissions
chmod a-x ChangeLog license.txt


%build
mkdir build
pushd build
export MINGW32_CFLAGS="%{mingw32_cflags} -DWIN32"
%{mingw32_cmake} ..
make %{?_smp_mflags}
popd


%install
pushd build
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{mingw32_bindir}
mv $RPM_BUILD_ROOT%{mingw32_libdir}/libopenjpeg.dll $RPM_BUILD_ROOT%{mingw32_bindir}
popd

# HACK: until pkg-config support lands, temporarily provide
# openjpeg.h header in legacy location
ln -s openjpeg/openjpeg.h $RPM_BUILD_ROOT%{mingw32_includedir}/openjpeg.h


%check
# mostly pointless without test images, but it's a start -- Rex
make test -C build


%files -n mingw32-openjpeg
%doc license.txt
%{mingw32_includedir}/openjpeg.h
%{mingw32_includedir}/openjpeg
%{mingw32_bindir}/libopenjpeg.dll
%{mingw32_libdir}/libopenjpeg.dll.a


%changelog
* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Mar 07 2012 Kalev Lember <kalevlember@gmail.com> - 1.3-9
- Renamed the source package to mingw-openjpeg (#801008)
- Modernize the spec file
- Use mingw macros without leading underscore

* Tue Feb 28 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 1.3-8
- Rebuild against the mingw-w64 toolchain

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Nov 16 2009 Adam Goode <adam@spicenitz.org> - 1.3-5
- Initial release, tracking Fedora native openjpeg-1.3-5
